; Lemmingz [TI-86 Version] created by                  Christopher Tremblay "ti_chris@yahoo.com"
; Version 0.99 (Last revised 2000/06/23)										   Legendz (IRC)
; (Best viewed with tabspacing set to 4)
;
; This code does *NOT* compile with TASM (bin) or AsmEdit (.SAV) because of the 8K limit
;
; Personal Bug List :
;						?  Porting the game to the 85/68K?
;						?  Optimizing for jumps (m, p = c, nc) (9x)
;					  +  Enable the fades (+27)
;				*  Heavy testing on the 2P mode
;-----------------------------------------------------------------------
;				~  Current memory overlap = 9120 | 9117/9144 = -50/-23
#include "ram86.h"
#include "rom86.h"
#include "asm86.h"

#define ShortT
#define LongT
#define Fades

#define Emul
;#define Und

.org _asm_exec_ram

Start:
	call _runindicoff
	res  appTextSave, (iy + appflags)					; No shadowing here boy!

	xor  a
	ld   (Window), a
	ld   (BootTmp), a

#ifndef Emul
	ld   a, (0C008h)
	ld   (OldCont), a
#endif

	ld   a, %01000001
 	out  (5), a

	call LoadInt

	ld   hl, Page1a
	call ClearPage

	ld   hl, Page2a
	call ClearPage


; Show the starting screen!
ChooseP:												; Yes.... I know!!!
	ld   hl, Drawing
	ld   de, Page2a
	call DeComp

	ld   de, Page2b
	call DeComp

	ld   hl, WaStep1
	ld   a, (BootTmp)
	add  a, a
	ld   b, a
	add  a, a
	add  a, a
	add  a, b

	add  a, 25
	ld   b, 30
	call DrawSprite										; Draw our lemming (cursor)

	ld   bc, 64 * 128 / 8
	call FlipPages

	ld   a, %01111110
	out  (1), a
	in   a, (1)
	in   a, (1)

	bit  Up, a
	jr   nz, NGoUp

	xor  a
	ld   (BootTmp), a
	jr   ChooseP

NGoUp:
	bit  Down, a
	jr   nz, NGoDown

	ld   a, 1
	ld   (BootTmp), a

NGoDown:
	ld   a, %00111111
	out  (1), a
	in   a, (1)
	in   a, (1)

	bit  Second, a
	jr   nz, ChooseP

NotChooseP:
	call GetEnter
	call Quit

	ld   a, (BootTmp)
	or   a												; cp   P1
	jr   z, IsNotP2

	call CheckID
	ld   a, d
	inc  a
	ld   (BootTmp), a									; Preserve who's master and who's slave

IsNotP2:
; Load the level										  ahl = Level Data
#include "LoadExt.asm"
	jp   c, Quit										; No levels are avaible!

	call _ahl_plus_2_pg3								; Skip the signature
	call _ahl_plus_2_pg3								; Length

; Procedure called to load a sub-level
; [In]   : ahl = Level 24bit pointer
LoadSubLev:
#ifndef Emul
	push af
	xor  a
	out  (2), a											; Blank the screen fully white
	pop  af
#endif

	call _set_abs_src_addr
	call _getb_ahl										; Get the first byte
	or   a
	jp   z, Quit										; There's no more levels left!

	call _get_abs_src_addr
	push af
	push hl

	xor  a
	ld   hl, 0A00h
	call _set_mm_num_bytes

	ld   h, 0E0h
	call _set_abs_dest_addr

	call _mm_ldir										; Copy the level over the game

	ld   a, %01000001
	out  (6), a											; Get a free RAM page

	ld   de, 0A000h
	ld   b, e
	call DeComp

	ld   b, 020h
	add  hl, bc											; hl = Delta

	pop  de
	pop  af
	push af
	push de

	add  hl, de
	adc  a, c
	push af
	push hl												; Preseve the level address

	ld   hl, Var
	rst  20h
	rst  10h
	call _ex_ahl_bde
	call _get_word_ahl
	call _ahl_plus_2_pg3
	call _set_abs_src_addr

	xor  a
	ex   de, hl
	call _set_mm_num_bytes

	ld   hl, 0D748h
	call _set_abs_dest_addr


#ifndef Emul
OldCont	 equ $ + 1
	ld   a, 0
	push af
#endif
	call _mm_ldir										; re-copy the game

#ifndef Emul
	pop  af
	ld   (MaxCont), a
#endif

	ld   a, %01000001
	out  (6), a											; Get a free RAM page

	ld   hl, 0A000h
	ld   de, SrcPa
	ld   bc, 256 * 52 / 8
	push bc
	ldir

	ld   de, SrcPb
	pop  bc
	push bc
	ldir

	ld   de, Under
	pop  bc
	ldir

	ld   de, Waves
	ld   c, 128
	ldir

	ld   de, LevVar
	ld   c, 36
	ldir

	ld   de, Desc
	ld   c, 50
	ldir

	ld   de, LemInS1
	ld   c, 150
	ldir												; Copy LemIns[123]

	ld   a, (BootTmp)
	ld   (Players), a									; Copy from safe to level info.

; Setup the timer & Total Lemmingz left aswell as the presets
	xor  a
	ld   (OutPatch), a
	ld   (MyLemIn), a									; Reset the amounth of lemmings in
	ld   (HisLemIn), a

	ld   (LemPos + State), a
	ld   (LemPos + State + 5), a
	ld   (32 * 5 + LemPos + State), a					; State
	ld   (OutLem), a

	dec  a
	ld   (LemAdd), a									; Next lemming out (*5)

	ld   a, (LevVar + TotLem)
	inc  a
	ld   (TotOLem), a

	ld   hl, LemPos
	ld   (Preset), hl
	ld   hl, Preset
	ld   de, Preset + 2
	ld   c, (8 - 1) * 2
	ldir												; Set the presets as the first lemming

; Setup the first lemming, then we can clone the rest
; Common Values
	ld   hl, LevVar + StartX
	ld   de, LemPos + X
	push de

	ld   a, (hl)
	dec  a
	ld   (de), a								; X

	inc  hl
	inc  de

	ld   a, (hl)
	and  07Fh
	add  a, 8
	ld   (de), a								; Y

	inc  de

	ld   a, (hl)
	rra
	and  %01000000
	add  a, %10100000
	ld   (de), a							; Action


; Mode dependant values
	ld   hl, LevVar + StartX2

	ld   a, (Players)
	or   a												; cp   P1
	jr   nz, Init2P										; Is there one or 2 players?

	ld   de, LemPos + X + 5

	ld   a, (hl)
	dec  a
	ld   (de), a							; X

	inc  hl
	inc  de

	ld   a, (hl)
	ld   c, a
	and  07Fh
	add  a, 8
	ld   (de), a							; Y

	inc  de

	ld   a, c
	rra
	and  %01000000
	add  a, %10100000
	ld   (de), a						; Action

	ld   de, LemPos + (5 * 2)
	ld   bc, (64 - 2) * 5
	jr   DoneLemSetup

Init2P:
	ld   de, 32 * 5 + LemPos + X
	push de

	ld   a, (hl)
	dec  a
	ld   (de), a										; X

	inc  hl
	inc  de

	ld   a, (hl)
	ld   c, a
	and  07Fh
	add  a, 8
	ld   (de), a										; Y

	ld   a, c
	rra

	inc  de

	and  %01000000
	add  a, %10100000
	ld   (de), a					; Action

	pop  hl
	ld   de, LemPos + ((32 + 1) * 5)
	ld   c, (32 - 1) * 5
	ldir

	ld   de, LemPos + 5
	ld   c, (32 - 1) * 5

DoneLemSetup:
	pop  hl
	ld   (MyLem), hl
	ldir

	ld   hl, LevVar + Trap1A
	ld   de, Flame1C
	ld   b, 3

FlameSetupLoop:
	ld   a, (hl)
	or   a
	jr   nz, NotNil

	dec  a												; a == 0FFh
	jr   SkipMask

NotNil:
	and  %00111111
SkipMask
	ld   (de), a
	inc  de
	inc  hl
	inc  hl
	inc  hl
	inc  hl
	djnz  FlameSetupLoop

	ld   a, 0Dh
	out  (5), a											; Let's be nice and Give back D ROM page
														; <Late night jokes>
	call _clrLCD

	ld   h, 0

; Get our numbers from the TI OS (They better make this a standard in the future)
	ld   ix, Number0 - 5
	ld   b, 10
GetNumLoopNum:
	ld   l, h
	ld   (_penCol), hl

	push ix
	ld   a, '9' + 1
	sub  b
	call _vputmap
	pop  ix

	ld   d, h
	ld   c, 5
	ld   e, c
	add  ix, de
	ld   e, 16
	ld   h, 0FCh

GetNumLoop:
	add  hl, de
	ld   a, (hl)
	ld   (ix), a
	ld   (ix + 5), a
	inc  ix
	dec  c
	jr   nz, GetNumLoop
	ld   h, c

	djnz GetNumLoopNum


; Calculate the Reversed lemmings sprites (opt. for size)
	ld   hl, RevData
	ld   de, Data
	ld   bc, RevLen + 256								; +1High for "dec, jnz"

FlipLoop:
	push bc												; Yah!  This is gonna be shitty slow!
	ld   b, 8											; but we don't care since it's !runtime
	ld   a, (de)										; Not unrolled & using push = Slow.

FlipBase:
	rra
	rl   c
	djnz FlipBase

	ld   (hl), c
	pop  bc

	inc  de
	inc  hl
	dec  c
	jr   nz, FlipLoop
	dec  b
	jr   nz, FlipLoop

	di													; We must do this for the "ex" instrs.
; Flip the flame 90
	ld   hl, SideFlame1									; hl = Source

	exx
	ld   de, TopFlame1									; de' = Destination
	ld   hl, RevTopFlame + 0Fh							; hl' = Reversed Destination
	ld   bc, 00800h										; c'  = Current position within the word
														; b'  = Number of (word/sprites) to draw
RotateS:
	exx
	ld   c, 8											; c   = X length (for 1 byte)
	ld   de, BitMap										; de = BitMap (bit7..bit0)
	jr   RotateN

RotateY:
	pop  hl
RotateN:
	push hl
	ld   b, 8											; b  = Y length (1bit per Y)
	xor  a												; a  = data bit

RotateX:
	add  a, a
	ld   (OldMask), a
	ld   a, (de)
	and  (hl)
OldMask  equ $ + 1
	ld   a, 1
	jr   z, NoChange

	inc  a												; Set the last bit on!
NoChange:
	inc  hl
	djnz RotateX										; Adds all the x's bits in the sprite

	inc  de												; Do the next bit!
	exx
	ld   (de), a
	inc  de
	ld   (hl), a
	dec  hl
	exx													; Save & point to the next byte

	dec  c
	jr   nz, RotateY									; Does it for all bits in the byte

	pop  af												; Don't restart the pointer (hl)

	exx

	inc  c
	ld   a, 3
	and  c
	ld   c, a

	push bc

	bit  0, a
	jr   z, IsOdd										; We have to jump around the sprite
														; like this because of the way the
	ld   bc, 00008h										; SideFlame sprie is stored :
	ex   de, hl											; [gry1 p1][gry2 p1][gry2 p1][gry2 p2]
	add  hl, bc
	ld   c, 24
	jr   KeepRot

IsOdd:
	bit  1, a
	jr   z, CheckEnd

	ld   bc, -16
	ex   de, hl
	add  hl, bc

KeepRot:
	ex   de, hl
	add  hl, bc
	pop  bc
	jr   RotateS

CheckEnd:
	ld   bc, 32
	add  hl, bc

	pop  bc
	djnz RotateS


; Flip the sprites which are more then 8 bits in length (only Flames for now)
	ld   hl, SideFlame1 - Data + RevData - 10h
	exx
	ld   b, 8

LongLoop:
	exx
	ld   bc, 10h
	add  hl, bc

	ld   d, h
	ld   e, l											; Only used for the first case!
	add  hl, bc
	ex   de, hl

	ld   b, c
FlipLong:
	ld   a, (de)
	ld   c, (hl)
	ld   (hl), a
	ld   a, c
	ld   (de), a
	inc  hl
	inc  de
	djnz FlipLong

	exx
	djnz LongLoop


PrepInit:
	call SetInt

	ld   hl, Page1a
	call ClearPage

	ld   hl, 0342Ah
	ld   (_penCol), hl

	ld   hl, TimeS
	call _vputs

	xor  a
	ld   hl, Desc
	call SetBack

; Show a crunched screenshot of the level
	ld   hl, SrcPa
	ld   de, Page1a + 4 + (8 * 16)
	call DrawLev

	ld   hl, SrcPb
	ld   de, Page1b + 4 + (8 * 16)
	call DrawLev

	ld   b, 040h
	ld   de, 02901h
	ld   hl, LevVar + LemNeed
	call WriteNumber

	ld   b, 40h
	ld   de, 02F01h
	ld   hl, LevVar + TotLem
	call WriteNumber

	ld   bc, 04008h
	ld   de, 03502h
	ld   hl, LevVar + Min
	call WriteNumber


#ifndef Emul
	call FadeIn
#endif
	call GetEnter

; Show the lower bar
	ld   hl, BottomPa
	ld   de, Page1a + (52 * 128 / 8)
	ld   bc, 12 * 128 / 8
	push bc
	ldir

	ld   de, Page1b + (52 * 128 / 8)
	pop  bc
	ldir

	call WriteVal
	ld   hl, (LevVar + Min)
	ld   (MinLeft), hl									; Init the main timer

; Here starts the main speed *critial* area of the game
UpdateTimer:
	ld   hl, BottomPa + ((56 - 52) * 16) + 11
	ld   de, Page1a + (56 * 16) + 11
	call Kill6

	ld   hl, BottomPb + ((56 - 52) * 16) + 11
	ld   de, Page1b + (56 * 16) + 11
	call Kill6

	call WriteTime

	ld   hl, InGame
	ld   (ShowPtch), hl									; Reset the patch!

; The Main game loop start here!
InGame:
	ld   a, GameSpd										; Frames per second
	ld   (STimer), a									; Set the timer

OutPatch equ $ + 1
	jr   $ + 2

	ld   a, (LevVar + SpdLem)
	ld   b, a

	ld   a, (LemAdd)
	inc  a
	ld   (LemAdd), a
	cp   b
	jr   nz, SkipOut

	xor  a
	ld   d, a
	ld   (LemAdd), a
	ld   a, (OutLem)
	ld   e, a
	add  a, 5
	ld   (OutLem), a

	ld   a, (TotOLem)
	dec  a
	ld   (TotOLem), a
	jr   nz, SkipStopOut

	ld   a, SkipOut - OutPatch - 1
	ld   (OutPatch), a
	jr   SkipOut

SkipStopOut:
	ld   hl, LemPos + Action
	add  hl, de
	ld   a, (hl)

	bit  First, a
	jr   z, SkipFirst									; Make sure he's set to go out!

	and  %01011111
	ld   (hl), a										; Mask Out IsDead and First

SkipFirst:
	ld   a, (Players)
	or   a												; cp   P1
	jr   z, SkipOut

	ld   de, 5 * 32
	add  hl, de
	ld   a, (hl)
	and  %01011111
	ld   (hl), a										; do the second player aswell

SkipOut:
	ld   a, (Flame1C)
	cp   8
	jr   nc, CheckFlame2

	ld   bc, (LevVar + Trap1X)
	ld   a, (LevVar + Trap1A)
	call CheckFlame

CheckFlame2:
	ld   a, (Flame2C)
	cp   8
	jr   nc, CheckFlame3

	ld   bc, (LevVar + Trap2X)
	ld   a, (LevVar + Trap2A)
	call CheckFlame

CheckFlame3:
	ld   a, (Flame3C)
	cp   7
	jr   nc, SkipFlame

	ld   bc, (LevVar + Trap3X)
	ld   a, (LevVar + Trap3A)
	call CheckFlame

SkipFlame:
	ld   hl, LemPos + Time
	ld   b, 64
	ld   de, 5											; Timer preperation variables

IncTimer:
	dec  (hl)
	add  hl, de
	djnz IncTimer										; Update the Bomber's timer

	ld   hl, LemPos + Action
	ld   a, (LevVar + TotLem)
	ld   c, a
	add  a, a
	add  a, a
	add  a, c											; a = TotLem * 5
	add  a, l
	ld   l, a
	ld   a, h
	adc  a, 0
	ld   h, a											; hl = hl - TotLem * 5
	
	bit  First, (hl)
	jr   nz, NotAllOut									; If they're not all out yet...
										; revise this here!
	ld   hl, LemPos + Action
	ld   a, 64
	ld   b, a

CheckFatal:	
	bit  IsDead, (hl)
	jr   z, NotFatal
	dec  a

NotFatal:
	add  hl, de
	djnz CheckFatal

	or   a
	jp   z, LevOut										; All the lemmingz are dead!


NotAllOut:
	ld   hl, Flame1C
	ld   de, LevVar + Trap1C
	ld   b, 3
FIncLoop:
	ld   a, 0FFh
	cp   (hl)
	jr   z, NotUpdTime									; If the flame doens't exist...

	ld   a, (de)
	inc  (hl)
	cp   (hl)	
	jr   nz, NotUpdTime

	ld   (hl), 0

NotUpdTime:
	inc  hl
	inc  de
	inc  de
	inc  de
	inc  de
	djnz FIncLoop
	

; This here is looped until the timer times out where it'll do the actions
GameLoop:
	ld   a, %00111111
	out  (1), a
	in   a, (1)											; F1, F2, F3, F4, F5, 2nd
	ld   b, a
	ld   c, 5											; c = key Counter
	
 	bit  Exit, a										; Check for the "Exit" key
	jr   nz, ScaniS

;	ld   a, SkipOut - OutPatch - 1
;	ld   (OutPatch), a

	ld   hl, LemPos + Action + (31 * 5)
	ld   bc, 02001h										; 2P setup

	ld   a, (Players)
	or   a												; cp   P1
	jr   nz, ArmMine

	ld   b, 40h
	ld   hl, LemPos + Action + (63 * 5)					; 1P setup

ArmMine:
	ld   de, -2 -5

ArmLem:
	set  Bomb, (hl)										; Set the bomber
	res  First, (hl)									; No more falling out!
	inc  hl
	inc  hl
	ld   (hl), c
	add  hl, de
	inc  c
	djnz ArmLem
	jp   StartDraw

ScaniS:
	rra
	jr   nc, GotOne
	dec  c
	jr   nz, ScaniS										; cx = 0 if nothing found
	jr   SkipNewKey

GotOne:
	ld   a, c
	bit  Second, b
	jr   nz, NotFSec
	add  a, 5 - 2

NotFSec:
	ld   (CurKey), a									; Preserve the required action

SkipNewKey:
	ld   a, %01111110
	out  (1), a
	in   a, (1)											; Scan row 1 [L/R/U/D]

	bit  Second, b
	jr   nz, NotSec

; At this point, All the keys which are pressed will result in a direct action
CheckSetDir:
	bit  Left, a
	jp   z, ChooseLeft

NotLeft:
	bit  Right, a
	jp   z, ChooseRight

NotRight:
	bit  Up, a
	jp   z, ChooseUp

NotUp:
	bit  Down, a
	jp   z, ChooseDown
	jr   StartDraw


NotSec:
	ld   b, a
	ld   a, %11011111
	out  (1), a
	in   a, (1)
	bit  Alpha, a
	jr   nz, NotSAlpha

; Check for anything that could make our screen flip from left to right
	ld   a, b
	bit  Left, a										; Check for the "Left" key
	jr   nz, NotSLeft

	ld   hl, Window
	dec  (hl)
	bit  7, (hl)
	jr   z, StartDraw
	inc  (hl)
	jr   StartDraw

NotSLeft:
	bit  Right, a										; Check for the "Right" key
	jr   nz, NotSRight

	ld   a, 17
	ld   hl, Window
	inc  (hl)
	cp   (hl)
	jr   nz, StartDraw
	dec  (hl)
	jr   StartDraw

NotSRight:
	bit  Up, a
	jr   nz, NotSUp

	ld   a, (0C008h)
	inc  a
	cp   32
	jr   z, StartDraw
	out  (2), a
	ld   (0C008h), a
	jr   StartDraw

NotSUp:
	bit  Down, a
	jr   nz, NotSDown

	ld   a, (0C008h)
	dec  a
	cp   0FFh
	jr   z, StartDraw
	out  (2), a
	ld   (0C008h), a
	jr   StartDraw

NotSDown:
	call CheckPreset									; If it overflows, we don't care! (8)
	ld   a, (MyLem)
	ld   (hl), a
	inc  hl
	ld   a, (MyLem + 1)
	ld   (hl), a										; Save our preset
	jr   StartDraw

NotSAlpha:
	ld   a, b
	and  %00011111
	cp   %00011111
	jr   z, NotDir										; Make sure we're allowed to do it!

OldKey	 equ $ + 1
	cp   0
	jr   z, NotDir

	ld   (OldKey), a
	jp   CheckSetDir

NotDir:
	ld   (OldKey), a


StartDraw:
	call ShowWin										; Draw the background

; Draw the entry door and exit door
	ld   hl, LevVar + StartX2
	ld   a, (LevVar + StartX)
	cp   (hl)
	jr   z, CheckYY2
	jr   AreNotSame

CheckYY2:
	ld   a, (LevVar + StartY)
	and  07Fh
	ld   b, a
	ld   a, (LevVar + StartY2)
	and  07Fh
	cp   b
	jr   z, AreSame

AreNotSame:
	ld   hl, MEntry
	ld   a, (LevVar + StartX2)
	sub  8
	ld   b, a
	ld   a, (LevVar + StartY2)
	and  07Fh
	call DrawSprite										; Draw (X - 8, Y)	[Entry, Part 1]

	ld   hl, MEntry + (8 * 2)
	ld   a, (LevVar + StartX2)
	ld   b, a
	ld   a, (LevVar + StartY2)
	and  07Fh
	call DrawSprite										; Draw(X, Y) 		[Entry, Part 2]

; Now for the Exit doors
	ld   hl, MExit
	ld   a, (LevVar + EndX2)							; The Exit should follow the entry
	sub  4
	ld   b, a
	ld   a, (LevVar + EndY2)

	sub  8
	call DrawSprite										; Draw (X, Y)		[Exit]

AreSame:
	ld   hl, MEntry
	ld   a, (LevVar + StartX)
	sub  8
	ld   b, a
	ld   a, (LevVar + StartY)
	and  07Fh
	call DrawSprite										; Draw (X - 8, Y)	[Entry, Part 1]

	ld   hl, MEntry + (8 * 2)
	ld   a, (LevVar + StartX)
	ld   b, a
	ld   a, (LevVar + StartY)
	and  07Fh
	call DrawSprite										; Draw(X, Y) 		[Entry, Part 2]

	ld   hl, MExit
	ld   a, (LevVar + EndX)								; The Exit should follow the entry
	sub  4
	ld   b, a
	ld   a, (LevVar + EndY)
	sub  8
	call DrawSprite										; Draw (X, Y)		[Exit]

; Now draw the flames (U/D/L/R)
	ld   hl, Flame1C
	ld   (FlameCount), hl
	ld   hl, LevVar + Trap1A
	ld   (FlameAttr), hl
	ld   a, 3
	ld   (FlameMCount), a

KeepFCount:
	ld   de, 0

FlameCount	equ $ + 1
	ld   hl, Flame1C
	ld   a, (hl)
	cp   8
	jr   nc, FlameLoop									; The trap is not currently active
	and  a												; Clear the flag
	rla
	rla
	rla
	rla
	rla													; Calculate the Flame's frame

FlameAttr	equ $ + 1
	ld   hl, 0
	bit  6, (hl)
	jr   z, SkipFlip									; Flip or not?

	bit  7, (hl)
	jr   nz, MakeSide

	ld   de, RevTopFlame - TopFlame1
	jr   SkipFlip

MakeSide:
	ld   de, RevData - Data								; bc = Data Delta

SkipFlip:
	add  a, e
	ld   e, a
	ld   a, d
	adc  a, 0
	ld   d, a											; Add the frames to the Delta

	dec  hl
	dec  hl
	ld   b, (hl)										; Set a & b for the DrawSprite routine
	inc  hl
	ld   a, (hl)
	inc  hl
	cp   64
	jr   nc, FlameLoop									; There isn't a Flame!

	bit  7, (hl)
	jr   nz, FlameSide

	ld   hl, SpriteLen
	ld   c, 16
	ld   (hl), c
	ld   hl, GrayDelta
	ld   (hl), c

	ld   hl, TopFlame1
	add  hl, de											; Add the direction to it!
	call DrawSprite

	jr   FlameLoop

FlameSide:												; DEBUG
	ld   hl, SideFlame1
	add  hl, de
	push af
	push bc
	push hl
	call DrawSprite

	pop  hl
	pop  af
	ld   de, 8
	add  a, e
	ld   b, a
	add  hl, de
	add  hl, de
	pop  af
	call DrawSprite

FlameLoop:
	ld   hl, (FlameCount)
	inc  hl
	ld   (FlameCount), hl								; Increment the flame counter
	ld   hl, (FlameAttr)
	ld   de, 04
	add  hl, de
	ld   (FlameAttr), hl								; Increment to the next frame

FlameMCount	equ $ + 1
	ld   a, 0
	dec  a
	ld   (FlameMCount), a
	jr   nz, KeepFCount

; Now check the keyboard's preset keys
	call CheckPreset
	ld   a, 8 * 2
	cp   c
	jr   z, SkipSet

	ld   a, (hl)
	ld   (MyLem), a
	inc  hl
	ld   a, (hl)
	ld   (MyLem + 1), a									; Load the preset

SkipSet:
	ld   a, (LevVar + TotLem)							; Total number of lemmings
	ld   ix, LemPos

; Draw the lemmings in the flip buffer
MoreDraw:
	push af

	ld   a, (Players)
	or   a												; cp   P1
	jr   z, DrawMine

	push ix
	ld   bc, 32 * 5
	add  ix, bc
	ld   a, Page2b / 400h
	ld   (DrawPage + 1), a
	ld   a, DeltaR
	ld   (Del1), a
	ld   (Del2), a
	ld   (Del3), a
	ld   (Del4), a										; Make his lemmings look diffrent

#ifndef  Und
	call DrawLem
#endif

	ld   a, Page2a / 400h
	ld   (DrawPage + 1), a
	ld   a, Delta
	ld   (Del1), a
	ld   (Del2), a
	ld   (Del3), a
	ld   (Del4), a										; Set the colors back to the basics
	pop  ix

DrawMine:
#ifndef  Und
	call DrawLem
#endif

	ld   bc, 5
	add  ix, bc											; Show the next lemming
	pop  af
	dec  a
	jr   nz, MoreDraw

; Update the bottom wave
WaveFrm	 equ $ + 1
	ld   a, 0
	add  a, a
	add  a, a
	add  a, a
	add  a, a											; Frame * 8
	inc  a												; HARDCODED for 86map

	ld   l, a
	ld   h, Waves / 100h
	ld   de, (52 - 8) * 16 + Page2a
	call DrawOrLine

	ld   de, (52 - 8) * 16 + Page2b
	call DrawOrLine
	

; Flip the screen so that we can see the changes
	ld   bc, 52 * 128 / 8
	call FlipPages

	ld   a, (STimer)
	cp   0
	jp   p, GameLoop									; Should we update a frame yet?

; Here we're updating a new frame...
	ld   a, (WaveFrm)
	inc  a
	and  7
	ld   (WaveFrm), a

	ld   a, (Players)
	or   a												; cp   P1
	jp   z, SkipSend									; Are we playing as one or 2 player?

; Calculcate the relative lemming position
	ld   hl, (MyLem)
	ld   b, h
	ld   c, l
	ld   hl, LemPos
	xor  a
	sbc  hl, bc											; hl = Long delta
	ld   c, a
	jr   z, IsFirst
	
	ld   a, l
	ld   b, 5

GetRelPos:
	inc  c
	sub  b
	jr   nz, GetRelPos									; Divide by 5 (The cheezy way)

	dec  c
IsFirst:
	ld   b, 6
	call Transfer										; Send MyLem

; Tranform his relative lemming position into real based address
	ld   hl, HisPos
	ld   a, d
	add  a, a
	add  a, a
	add  a, d											; a = a * 5

	add  a, l
	ld   l, a
	ld   a, h
	adc  a, 0
	ld   h, a
	ld   (HisLem), hl									; HisLem = LemPos + (32 + d) * 5

; Transfer the keys to the other player
	ld   b, 4											; Only [0..8] is used [9..15] are free
	ld   a, (CurKey)
	ld   c, a
	call Transfer										; Send the requested action

	ld   a, (Players)
	cp   P2S
	jr   z, UpdateSlave

	push de
	ld   ix, (MyLem)									; This marks the active lemming
	ld   hl, LevVar										; And now...  Let thy hand guide thee
	ld   bc, MyLem
	call CheckKey

	ld   a, (LevVar + TotLem)							; Total number of lemmings
	ld   ix, LemPos
	call MoreLem

	pop  af
	ld   (CurKey), a

	ld   ix, (HisLem)									; This marks the active lemming
	ld   hl, HisVar										; And now...  Let thy hand guide thee
	ld   bc, HisLem
	call CheckKey

	ld   a, (HisVar + TotLem)
	ld   ix, HisPos
	call MoreLem										; Now we're done!
	jr   ShowPtch - 1


UpdateSlave:											; Do his lemmingz fisrt
	ld   a, (CurKey)
	push af
	ld   a, d
	ld   (CurKey), a

	ld   ix, (HisLem)									; This marks the active lemming
	ld   hl, HisVar										; And now...  Let thy hand guide thee
	ld   bc, HisLem
	call CheckKey

	ld   a, (HisVar + TotLem)
	ld   ix, HisPos
	call MoreLem										; Once his lemmingz are updated, do ours
	pop  af
	ld   (CurKey), a

; Do Our lemmingz
SkipSend:
	ld   ix, (MyLem)									; This marks the active lemming
	ld   hl, LevVar										; And now...  Let thy hand guide thee
	ld   bc, MyLem
	call CheckKey

; Frame advacement
	ld   a, (LevVar + TotLem)							; Total number of lemmings
	ld   ix, LemPos
	call MoreLem

ShowPtch equ $ + 1 
	jp   InGame


; Routine called when there's no more lemmings on the scren
LevOut:
	ld   hl, Page1a
	call ClearPage

	ld   hl, InS

	ld   a, (Players)
	or   a												; cp   P1
	jr   z, No2PComm

	ld   hl, 0342Ah
	ld   (_penCol), hl

	ld   hl, TieS

	ld   a, (HisLemIn)
	ld   b, a
	ld   a, (MyLemIn)
	sub  b
	jr   z, Print

	jr   c, Lost
	
	ld   hl, WonS
	jr   Print

Lost:
	ld   hl, LostS
	
Print:
	call _vputs												; "In"

No2PComm:
	ld   hl, MyLemIn
	ld   a, (hl)
	push af
	push hl
	ld   hl, LevVar + LemIn1
	cp   (hl)
	jr   nc, Comm2

	ld   de, LemInS1
	jr   WriteComm

Comm2:
	inc  hl
	cp   (hl)
	jr   nc, Comm3
	
	ld   de, LemInS2
	jr   WriteComm

Comm3:
	ld   de, LemInS3
	
WriteComm:
	ex   de, hl
	ld   a, 1
	call SetBack

	ld   b, 040h
	ld   de, 02901h
	pop  hl
	call WriteNumber

	ld   b, 40h
	ld   de, 02F01h
	ld   hl, LevVar + LemNeed

	ld   a, (Players)
	or   a												; cp   P1
	jr   z, WriteNow

	ld   hl, HisLemIn

WriteNow:
	call WriteNumber

	dec  hl
	pop  af
	cp   (hl)

	pop  de
	pop  hl
	jr   c, NotSwap

	pop  af
	ex   (sp), hl
	push de

NotSwap:
	call GetEnter
	jr   z, PreQuit

#ifndef Emul
	call FadeOut
	ld   (OldCont), a
#endif

	call Quit											; Reset our screen
	pop  hl
	pop  af
	jp   LoadSubLev


PreQuit:
	pop  af
	pop  af
; This can also be called in order to restore the initial state of the calc B4 loading levels
Quit:													; Quit the game
	ld   a, 0Dh
	out  (5), a											; We need the ROM calls

	res  2, (iy + 23h)									; Stop our interrupt
	di
	im   1
	set  appTextSave, (iy + appflags)					; Set back the shadowing

	call _clrScrn
	ld   a, 3Ch
	out  (0), a											; Set VIDEO_MEM to first 0F000h

	ret													; Return to the OS



; Procecure to setup the background when either loading or ending the level
; [In]   : hl = Description string, a = 0, 1 (Init, End)
SetBack:
	push af
	exx

; Write the text which will correspond to the values we'll be writting...
	ld   hl, 01A00h
	ld   (_penCol), hl

	exx
	call _vputs												; Show the level description

	ld   hl, 0282Ah
	ld   (_penCol), hl

	ld   hl, InS
	call _vputs												; "In"

	ld   hl, 02E2Ah
	ld   (_penCol), hl

	ld   hl, OutS

	pop  af
	or   a
	jr   z, Write2

	ld   a, (Players)
	or   a												; cp   P1
	jr   z, Write2

	ld   hl, HisS

Write2:
	call _vputs												; "Out"

	ld   hl, Page1a
	ld   de, Page1b
	push de
	ld   bc, 1024
	ldir

	ld   hl, TileBckgnd1
	pop  de
	call DrawBkg

	ret


; Procedure to "or" a background given a 8x8 tile
; [In]   : hl = Source, de = destination
; [Out]  : 
; [Uses] : 
DrawBkg:
	exx
	ld   bc, 04008h
	exx
	ld   (NotResetT - 2), hl

ResetTile:
	ld   a, (hl)
	ld   c, a

	ld   b, 16
BkgMaskLoop:
	ld   a, (de)
	or   c
	ld   (de), a
	inc  de
	djnz BkgMaskLoop

	inc  hl
	exx
	ld   a, c
	dec  a
	and  %00000111
	ld   c, a
	dec  b
	push af
	exx
	or   a
	jr   nz, NotResetT

	ld   hl, 0

NotResetT:
	pop  af
	jr   nz, ResetTile
	ret


; Routine to draw a cropped sprite
; [In]   : hl = Source, de = Destination
; [Out]  :
; [Uses] :
DrawLev:
	exx  
	ld   b, 13
DrawY:
	exx
	ld   b, 8

DrawX:
	ld   c, 4
	xor  a
DrawLoop:
	add  a, a
	bit  6, (hl)
	jr   z, Not1On
	or   1

Not1On:
	add  a, a
	bit  2, (hl)
	jr   z, Not4On
	or   1

Not4On:
	inc  hl
	dec  c
	jr   nz, DrawLoop

	ld   (de), a
	inc  de
	djnz DrawX

	ld   bc, 3 * 32
	add  hl, bc

	ld   bc, 8
	ex   de, hl
	add  hl, bc
	ex   de, hl

	exx
	djnz DrawY
	ret


; Routine to check if a lemming is within the boundaries of a flame
; [In]   : b = X, c = Y, a = Attributes
; [Out]  :
; [Uses] :
CheckFlame:
	inc  c

	bit  6, a
	jr   z, IsVert

	ld   a, 7 + 7
	add  a, b
	ld   d, a
	ld   a, c
	add  a, 15
	ld   e, a
	jr   DoFlame

IsVert:
	ld   a, 15 + 7
	add  a, b
	ld   d, a
	ld   a, c
	add  a, 7
	ld   e, a

DoFlame:
	ld   hl, LemPos										; Source
	exx
	ld   a, 64
	ld   b, a

CKLoop:
	exx
	ld   a, (hl)										; First, check X
	inc  hl
	cp   c
	jr   c, NotBurn
	cp   e
	jr   nc, NotBurn

	ld   a, (hl)										; Now check Y
	cp   b
	jr   c, NotBurn
	cp   d
	jr   nc, NotBurn									; He's in the hot spot!

	inc  hl
	bit  Die, (hl)
	jr   nz, SkipHLP1

	set  Die, (hl)
	inc  hl
	ld   a, (hl)
	and  7

	push hl
	exx
	cp   Blocker
	call z, KillFake
	exx
	pop  hl

	ld   (hl), 0
	jr   SkipHLP2

NotBurn:	
	inc  hl
SkipHLP1:
	inc  hl	
SkipHLP2:
	inc  hl	
	inc  hl	
	exx
	djnz CKLoop

	ret


; Procedure to convert from scancolumn to linear word buffer
; [In]   : Null
; [Out]  : hl = buffer entry address
; [Uses] : af, bc, hl
CheckPreset:
	ld   a, %01101111
	out  (1), a
	in   a, (1)
	ld   bc, 00400h

Scan0S:
	rra
	jr   nc, Is0n
	inc  c
	djnz Scan0S

	ld   a, %01110111
	out  (1), a
	in   a, (1)
	ld   b, 4
Scan1S:
	rra
	jr   nc, Is0n
	inc  c
	djnz Scan1S
															; At this point, we'll overflow!
Is0n:
	ld   b, 0
	ld   a, c
	add  a, a
	ld   c, a
	ld   hl, Preset
	add  hl, bc
	ret


; Procedure to update and draw a set of lemmings
; [In]   : a = Number of lemmings, ix = First Lemming's position
; [Out]  : Null
; [Uses] : af, bc, de, hl, ix
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
MoreLem:
	push af

	bit  IsDead, (ix + Action)
	jp   nz, SkipUpd									; It's dead, don't draw it :(

; Maybe he's in the process of dying?
	bit  Die, (ix + Action)
	jr   z, CheckIn										; It's dying? :~(

	ld   a, (ix + Frames)
	cp   %00110111
	jp   m, IsUpd

	set  IsDead, (ix + Action)							; Mark it as dead :~(
	jp   SkipUpd										; Make it jump to the climbing code!

; Maybe he's done with the level?
CheckIn:
	ld   a, (LevVar + EndX)
	cp   (ix + X)
	jr   z, CheckInY
	dec  a
	cp   (ix + X)
	jr   nz, CheckIn2

CheckInY:
	ld   a, (LevVar + EndY)
	cp   (ix + Y)
	jr   z, OkY
	dec  a
	cp   (ix + Y)
	jr   z, OkY

CheckIn2:
	ld   a, (LevVar + EndX2)
	cp   (ix + X)
	jr   z, CheckInY2
	dec  a
	cp   (ix + X)
	jp   nz, CheckBomb

CheckInY2:
	ld   a, (LevVar + EndY2)
	cp   (ix + Y)
	jr   z, OkY
	dec  a
	cp   (ix + Y)
	jr   nz, CheckBomb

OkY:
	bit  Ezit, (ix + Action)
	jr   z, SetExit

	ld   a, (ix + Frames)
	and  %11111000
	cp   %00111000
	jp   nz, IsUpd

	ld   a, (Players)
	or   a												; cp   P1
	jr   z, MineIn

	and  a
	ld   hl, LemPos + (31 * 5)
	push ix
	pop  bc
	sbc  hl, bc
	jr   nc, MineIn

	ld   a, (HisLemIn)
	inc  a
	ld   (HisLemIn), a
	jr   HisIn

MineIn:
	ld   a, (MyLemIn)
	inc  a
	ld   (MyLemIn), a

HisIn:
	call WriteIO

	set  IsDead, (ix + Action)
	jp   SkipUpd										; Bit (Exit and IsDead) should be on!


SetExit:
	set  Ezit, (ix + Action)							; Set him as exiting!
	ld   (ix + State), 0
	jp   IsUpd

CheckBomb:
	bit  Bomb, (ix + Action)
	jr   z, CheckClimbing

; My lemming's a bomb! <[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><
	ld   a, (ix + Time)
	or   a
	jr   nz, CheckBFrame

	ld   b, a											; Preserve "a"
	ld   a, (ix + State)
	and  %00000111
	cp   Blocker
	ld   a, b
	jr   nz, NotBBlock
	call KillFake

NotBBlock:
	ld   (ix + State), 0								; Set as frame 0
	jr   CheckClimbing

CheckBFrame:
	jp   p, CheckClimbing
	cp   -5
	jr   nz, NotBoom									; Make a hole :)

	ld   a, (ix + X)
	sub  7
	ld   c, a
	ld   a, (ix + Y)
	sub  9
	ld   h, Under / 800h
	ld   b, 14
	ld   de, BombMp
	call MaskAnd

	ld   c, (ix + X)
	dec  c
	ld   a, (ix + Y)
	sub  9
	ld   h, Under / 800h
	ld   b, 14

	ld   de, BombMp - Data + RevData
	call MaskAnd
	xor  a

NotBoom:
	cp   -7
	jp   nz, IsUpd										; Is he done enlarging?

	set  IsDead, (ix + Action)							; He's dead :(
	jp   SkipUpd

CheckClimbing:
; Check if he's climbing!?
	ld   a, (ix + State)
	and  %00000111
	cp   Climber
	jp   z, HasGround									; If he's climbing he has no ground!!!

; First, check if there's any ground under our lemming
	ld   e, (ix + X)
	ld   a, (ix + Y)
	inc  a

	call IsDirt										; Is there ground under our lemming?
	jr   nz, HasGround

IsFall:
	ld   a, (ix + State)
	and  %00000111
	cp   Blocker
	jr   nz, CheckFallH									; It's a blocker who's falling!

	push de
	push hl

	call KillFake										; Remove his old "fake" wall

	ld   b, c
	pop  hl
	pop  de

CheckFallH:
	ld   a, (ix + Y)
	cp   64 - 4
	jr   c, NotVoidD

	set  IsDead, (ix + Action)
	jp   SkipUpd										; You've gone too low my friend :(

NotVoidD:
	inc  (ix + Y)										; Fall down one pixel

	call CheckNextDirt
	jr   z, FallTwo

	ld   a, (ix + State)
	and  %00000111
	cp   Faller
	jp   z, IsUpd										; He was already falling!
	cp   Miner
	jp   z, IsUpd
	
	ld   (ix + State), 0								; make him stop his current action!
	jr   NotFall

FallTwo:
	bit  Float, (ix + Action)
	jr   z, NotFFloat
	ld   a, (ix + State)

	ld   b, a
	and  %00000111
	cp   Faller
	jr   nz, IsFall1
	jp   IsUpd											; it's a floater =)

NotFFloat:
	inc  (ix + Y)										; Fall down another step
	ld   a, (ix + State)
	and  %00000111
	cp   Faller
 	jp   z, IsUpd

	ld   a, (ix + State)
	and  %00000111
	cp   Faller
	jp   z, IsUpd

IsFall1:
	ld   (ix + State), Faller							; Set as falling down frame 0
	jp   IsUpd

HasGround:
	ld   a, (ix + State)
	ld   b, a
	and  %00000111
	cp   Faller
	jr   nz, NotFall									; Did he used to fall?

	bit  Float, (ix + Action)
	jp   nz, StopAction									; He has an unbrella :)

	ld   a, b
	cp   %00111000 + Faller
	jp   m, StopAction									; It's not high enough ;]

	xor  a
	ld   (ix + State), a								; Reset frames to 0!
	set  Die, (ix + Action)								; Set lemming as dying
	jp   IsUpd

NotFall:
	ld   a, (ix + State)
	and  %00000111										; a = Lemming' State

	cp   Walker
	jp   nz, NotWalk

; My lemming's Walking! <[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]>
	bit  Dir, (ix + Action)
	jr   z, WalkRight

	ld   e, (ix + X)
	dec  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt

	push hl
	push de
	jr   z, NoWallL										; Is there a wall at (X - 1, Y - 2)

	call CheckNextDirt
	jr   z, NoWallL										; Check (X - 1, Y - 1)

	ld   a, d
	sub  (SrcPb - SrcPa) / 100h
	ld   d, a											; Readjust the sourcing

	call CheckNextDirt
	jr   z, NoWallL										; Check (X - 1, Y)

	ld   e, (ix + X)
	inc  e
	push de
	dec  e
	dec  e
	dec  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt
	pop  de
	jr   z, NoWallL										; Is there a wall at (X - 2, Y - 2)

	bit  Climb, (ix + Action)
	call nz, SetClimb

	pop  de
	pop  hl
	res  Dir, (ix + Action)
	jp   IsUpd

NoWallL:
	pop  de
	pop  hl
	ld   a, (ix + X)
	dec  a
	jr   AdjustHeight


WalkRight:
	ld   e, (ix + X)
	inc  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt

	push hl
	push de
	jr   z, NoWallR										; Is there a wall at (X + 1, Y - 2)

	call CheckNextDirt
	jr   z, NoWallR										; Check (X + 1, Y - 1)

	ld   a, d
	sub  (SrcPb - SrcPa) / 100h
	ld   d, a											; Readjust the sourcing

	call CheckNextDirt
	jr   z, NoWallR										; Check (X + 1, Y)

	ld   e, (ix + X)
	dec  e
	push de
	inc  e
	inc  e
	inc  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt
	pop  de
	jr   z, NoWallR										; Is there a wall at (X + 2, Y - 2)

	bit  Climb, (ix + Action)
	call nz, SetClimb

	pop  de
	pop  hl
	set  Dir, (ix + Action)
	jp   IsUpd

NoWallR:
	pop  de
	pop  hl
	ld   a, (ix + X)
	inc  a

AdjustHeight:
	jr   c, IsVoid
	ld   (ix + X), a
	ld   bc, 32
	ex   de, hl
	add  hl, bc											; Return to the central focal point
	ex   de, hl

	call CheckNextDirt
	jr   z, WalkDown

	dec  (ix + Y)										; It's atlease one step higher!
	ld   a, d
	sub  (SrcPb - SrcPa) / 100h
	ld   d, a											; Readjust the sourcing

	ld   bc, 10000h - (32 * 2)
	ex   de, hl
	add  hl, bc
	ex   de, hl
	call CheckNextDirt
	jp   z, IsUpd

	dec  (ix + Y)
	jp   IsUpd


; This procedure is called if the lemming is found to have climbing abilities
SetClimb:
; First, check if he can climb given the wall's structure
	call ScanY
	ret  nz

	ld   e, (ix + X)
	call ScanY
	ret  nz

	ld   (ix + State), Climber
	pop  hl												; Clear the all
	pop  de
	pop  hl												; restore the state
	jp   IsUpd


; Routine to check a whole Y line for dirt
ScanY:
	ld   a, (ix + Y)
	sub  7												; Wasn't that an old game!?
	call IsDirt
	ret  nz

	exx
	ld   b, 5

CheckL:
	exx
	call CheckNextDirt
	ret  nz

	ld   a, d
	sub  (SrcPb - SrcPa) / 100h
	ld   d, a											; Readjust the sourcing

	exx
	djnz CheckL
	xor  a
	or   b
	ret


WalkDown:
	ld   a, d
	sub  (SrcPb - SrcPa) / 100h
	ld   d, a											; Re-adjust the sourcing

	call CheckNextDirt
	jp   nz, IsUpd

	ld   a, d
	sub  (SrcPb - SrcPa) / 100h
	ld   d, a											; Readjust the sourcing

	inc  (ix + Y)
	call CheckNextDirt
	jp   nz, IsUpd

	inc  (ix + Y)
	jp   IsUpd

IsVoid:
	set  IsDead, (ix + Action)
	jp   IsUpd

NotWalk:
	cp   Digger
	jr   nz, NotDig										; Is the lemming a digger?

; My lemming's Digging! <[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]>
	ld   a, (ix + Frames)
	and  %00011000										; 2 last frame bit must be of = 2^2=4
	cp   %00001000
	jp   nz, IsUpd										; Should we update during this frame?
														; It's updated every 4frames!
	ld   e, (ix + X)
	ld   a, (ix + Y)
	inc  a
	call IsHard
	jp   nz, StopAction

	ld   c, (ix + X)
	dec  c
	dec  c

	bit  Dir, (ix + Action)
	jr   z, IsRight
	dec  c

IsRight:
	ld   a, (ix + Y)
	inc  a
	ld   (ix + Y), a
	ld   h, Under / 800h								; Is it still hard under the lemming?
	ld   b, 1
	ld   de, DigMap
	call MaskAnd
	
	jp   IsUpd											; I used to have tables here for all the
														; 8 possible cases, but this method uses
														; lesser bytes =)
NotDig:
	cp   Miner
	jr   nz, NotMine

; My lemming's Mining! <[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]>
	ld   a, (ix + Frames)
	and  %00111000
	cp   %00011000
	jp   nz, IsUpd										; We're updating this every 8 frames

	bit  Dir, (ix + Action)								; Going right?
	jr   z, MineRight

	ld   e, (ix + X)
	dec  e
	ld   a, (ix + Y)
	inc  a
	call IsHard
	jp   nz, StopAction									; Is (X - 1, Y + 1) hard?

	ld   a, (ix + X)
	sub  8
	ld   c, a
	add  a, 8 - 3
	ld   (ix + X), a

	ld   a, (ix + Y)
	add  a, 3
	ld   (ix + Y), a	
	sub  6
	ld   h, Under / 800h
	ld   b, 8
	ld   de, MineMp - Data + RevData
	call MaskAnd

	jp   IsUpd

MineRight:
	ld   e, (ix + X)
	inc  e
	ld   a, (ix + Y)
	inc  a
	call IsHard
	jp   nz, StopAction										; Is (X + 1, Y + 1) hard?

	ld   a, (ix + X)
	inc  a
	ld   c, a
	add  a, 2
	ld   (ix + X), a

	ld   a, (ix + Y)
	add  a, 3
	ld   (ix + Y), a	
	sub  6
	ld   h, Under / 800h
	ld   b, 8
	ld   de, MineMp
	call MaskAnd

	jp   IsUpd


NotMine:
	cp   Basher
	jp   nz, NotBash									; No it's not the Unix shell =) <yukyuk>

; My lemming's Bashing! <[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]>
	bit  3, (ix + Frames)
	jp   nz, IsUpd										; Should we update it's movement?

	bit  Dir, (ix + Action)								; Going right or left?
	jr   z, BashRight
; Going left
	ld   e, (ix + X)
	dec  e
	dec  e
	dec  e
	ld   a, (ix + Y)
	sub  2
	call IsHard											; Are we trying to bash hard metal?
	jp   nz, StopAction									; (X - 1, Y + 5)

	dec  (ix + X)
	ld   a, (ix + X)
	sub  2 + 4
	ld   c, a
	ld   a, (ix + Y)
	sub  7
	ld   h, Under / 800h
	ld   b, 8
	ld   de, BashMp - Data + RevData
	call MaskAnd										; Remove the fisrt line!  Returns ab

	ld   a, (ix + Frames)
	and  %01110000
	cp   %01000000
	jp   nz, IsUpd										; Check every 4 frames

	ld   e, (ix + X)
	dec  e
	dec  e
	dec  e
	dec  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt											; Check (X - 2, Y + 5)
	jp   z, StopAction									; Maybe there's nothing to dig!?

	jp   IsUpd

BashRight:												; It's updated every 2frames
	ld   e, (ix + X)
	inc  e
	inc  e
	ld   a, (ix + Y)
	sub  2
	call IsHard											; Are we trying to bash hard metal?
	jp   nz, StopAction									; (X + 4, Y + 5)

	ld   c, (ix + X)
	inc  (ix + X)
	ld   a, (ix + Y)
	sub  7
	ld   h, Under / 800h
	ld   b, 8
	ld   de, BashMp
	call MaskAnd										; Remove the fisrt line!  Returns ab

	ld   a, (ix + Frames)
	and  %01110000
	cp   %01000000
	jp   nz, IsUpd										; Check every 4 frames

	ld   e, (ix + X)
	inc  e
	inc  e
	inc  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt											; Check (X + 3, Y + 5)
	jp   z, StopAction									; Maybe there's nothing to dig!?

	jp   IsUpd

NotBash:
	cp   Builder
	jp   nz, NotBuild

; My lemming's Building! <[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]
	ld   a, (ix + Frames)
	and  %00011000										; 2 last frame bit must be on = 2^2=4
	cp   %00011000
	jp   nz, IsUpd										; Should we update during this frame?

	bit  Dir, (ix + Action)								; Going right or left?
	jr   z, BuildRight

; Going left
	ld   a, (ix + X)
	sub  4
	ld   c, a
	ld   a, (ix + Y)
	ld   h, SrcPa / 800h
	ld   b, 1
	ld   d, BldMap
	call MaskOr

	ld   e, (ix + X)
	dec  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt
	jp   nz, StopAction

	ld   e, (ix + X)
	dec  e
	dec  e
	ld   a, (ix + Y)
	dec  a
	call IsDirt
	jp   nz, StopAction

	dec  (ix + Y)
	dec  (ix + X)
	dec  (ix + X)										; Update the lemmings' movement

	ld   a, (ix + Frames)
	and  %11111000
	cp   %11111000
	jp   nz, IsUpd

	jp   StopAction

BuildRight:
	ld   c, (ix + X)
	inc  c
	inc  c
	ld   a, (ix + Y)
	ld   h, SrcPa / 800h
	ld   b, 1
	ld   d, BldMap
	call MaskOr

	ld   e, (ix + X)
	inc  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt
	jp   nz, StopAction

	ld   e, (ix + X)
	inc  e
	inc  e
	ld   a, (ix + Y)
	dec  a
	call IsDirt
	jp   nz, StopAction

	dec  (ix + Y)
	inc  (ix + X)
	inc  (ix + X)										; Update the lemmings' movement

	ld   a, (ix + Frames)
	and  %11111000
	cp   %11111000
	jp   nz, IsUpd

	jp   StopAction

NotBuild:
	cp   Climber
	jp   nz, NotClimb

; My lemming's Climbing! <[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]><[]
	bit  3, (ix + Frames)
	jp   z, IsUpd										; Should we update during this frame?

	bit  Dir, (ix + Action)
	jr   z, ClimbRight									; Which direction?

	ld   e, (ix + X)
	ld   a, (ix + Y)
	sub  8
	call IsDirt
	jr   z, ClimbL										; Are we hitting the ceilling?

	ld   (ix + State), Faller
	ld   a, (ix + Action)
	xor  %01000000
	ld   (ix + Action), a
	jr   IsUpd

ClimbL:
	ld   e, (ix + X)
	dec  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt
	jr   nz, ClimbUp	

	dec  (ix + X)
	dec  (ix + Y)
	dec  (ix + Y)
	jr   StopAction										; There's no more wall to climb!

ClimbRight:
	ld   e, (ix + X)
	ld   a, (ix + Y)
	sub  8
	call IsDirt
	jr   z, ClimbR										; Are we hitting the ceilling?

	ld   (ix + State), Faller
	set  Dir, (ix + Action)
	jr   IsUpd

ClimbR:
	ld   e, (ix + X)
	inc  e
	ld   a, (ix + Y)
	sub  2
	call IsDirt
	jr   nz, ClimbUp	

	inc  (ix + X)
	dec  (ix + Y)
	dec  (ix + Y)

	jr   StopAction										; There's no more wall to climb!

ClimbUp:
	dec  (ix + Y)										; Make him climb up

NotClimb:
	jr   IsUpd


; Stops the lemming's previous action and makes him walk again
StopAction:
	ld   (ix + State), Walker
	jr   SkipUpd

IsUpd:
	ld   a, 8
	add  a, (ix + Frames)
	ld   (ix + Frames), a								; Update the frame

SkipUpd:
	ld   bc, 5
	add  ix, bc
	pop  af
	dec  a
	jp   nz, MoreLem									; Keep on until we have no more left
	ret


; Procedure to draw an aligned block sprite
; [In]   : a = Length, hl = Source, de = Destination
; [Out]  : Null
; [Uses] : af, bc, de, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
DrawPlay:
	ld   bc, 6
	ldir
	ld   bc, 16 - 6
	ex   de, hl
	add  hl, bc
	ex   de, hl
	dec  a
	jr   nz, DrawPlay
	ret


; Procedure to Erase the blocker if he dies or switches to a faller
; [In] : ix = Lemming's structure
; [Uses] : af, bc, de, hl 		[Out] : d = 0
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
KillFake:
	xor  a
	ld   (AndAddr), a									; We already had it up at Under
	ld   (AndPat1), a
	ld   (AndPat2), a

	ld   c, (ix + X)
	dec  c
	dec  c
	bit  Dir, (ix + Action)
	jr   z, BlockWrong
	dec  c

BlockWrong:
	ld   a, (ix + Y)
	sub  6
	ld   h, Under / 800h
	ld   de, BlokMp
	ld   b, 7
	call MaskAnd

	ld   a, SkipUnd - AndAddr - 1
	ld   (AndAddr), a									; Patch the MaskAND
	ld   a, 0B6h
	ld   (AndPat1), a
	ld   (AndPat2), a

	ret


; Procedure to let the lemming do *something*
; [In] : FKeys, AlphaOn, XVarOn, DelOn, hl = Src, ix = Chosen Lemming's structure, bc = Lem Dest
; [Uses] : af, bc, de, hl 
; [Out]  : Null
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
CheckKey:
	bit  IsDead, (ix + Action)
	ret  nz												; If the pointer is null, then don't act
CurKey	 equ $ + 1
	ld   b, 0											; b = FKey state

	xor  a
	cp   b
	ret  z												; If it's 0, there's nothing to do!

	ld   (CurKey), a

	dec  b
	jr   nz, NotF1										; Request to be a climber?

	bit  Climb, (ix + Action)
	ret  nz												; It already has it!

	ld   a, (hl)
	dec  a
	ret  m												; There's no more ressources left!

	ld   (hl), a
	set  Climb, (ix + Action)							; Set him up!

	jp   WriteVal										; It's return will make us exit the proc

NotF1:
	inc  hl
	dec  b
	jr   nz, NotF2										; Request to be a floater?

	bit  Float, (ix + Action)
	ret  nz												; Already one?

	ld   a, (hl)
	dec  a
	ret  m												; Out of ressources?

	ld   (hl), a
	set  Float, (ix + Action)

	jp   WriteVal										; It's return will make us exit the proc

NotF2:
	inc  hl
	dec  b
	jr   nz, NotF3										; Request to be a walking time bomb?

	bit  Bomb, (ix + Action)
	ret  nz												; Already one?

	ld   a, (hl)
	dec  a
	ret  m												; Out of ressources?

	ld   (hl), a
	set  Bomb, (ix + Action)

	ld   a, (5 * Frame) - 1
	ld   (ix + Time), a									; Reset it's time to 0 (nich, nada, nil)

	jp   WriteVal										; It's return will make us exit the proc

NotF3:
	ld   a, (ix + State)
	and  %00000111
	cp   Blocker
	ret  z				 								; You can't go from blocker to actions!
	cp   Faller
	ret  z												; You can't go from faller to actions!

	inc  hl
	dec  b
	jr   nz, NotF4										; Request to be a blocker?

	ld   a, (hl)
	dec  a
	ret  m												; Out of ressources?

	ld   (hl), a
	ld   c, (ix + X)
	bit  Dir, (ix + Action)
	jr   z, BlockRight
	dec  c

BlockRight:
	ld   a, (Under - SrcPb) / 100h
	ld   (OR2nd), a
	ld   a, (SrcPb - Under) / 100h
	ld   (ORAddr), a

	ld   a, (ix + Y)
	sub  5
	ld   h, SrcPb / 800h								; SrcPb to match with MaskAnd
	ld   b, 6
	ld   d, BlkMap
	push bc
	call MaskOr											; "Fake" a hard wall

	ld   d, BlkTMap
	ld   h, SrcPb / 800h								; SrcPb to match with MaskAnd
	pop  bc
	ld   b, 1
	dec  c												; Top level adjustement
	dec  c
	ld   a, (ix + Y)
	sub  3
	call MaskOr

	ld   a, (SrcPb - SrcPa) / 100h
	ld   (OR2nd), a
	ld   a, (SrcPa - SrcPb) / 100h
	ld   (ORAddr), a

	ld   a, Blocker
	ld   (ix + State), a

	jp   WriteVal										; It's return will make us exit the proc

NotF4:
	inc  hl
	dec  b
	jr   nz, NotF5										; Request to be a builder?

	ld   a, (ix + State)
	and  %00000111
	cp   Builder
	ret  z												; Already one?

	ld   a, (hl)
	dec  a
	ret  m												; Out of ressources?
	ld   (hl), a

	ld   e, (ix + X)
	ld   a, (ix + Y)
	inc  a
	call IsDirt
	ret  z												; Is there something under the lemming?

	ld   c, (ix + X)
	
	bit  Dir, (ix + Action)
	jr   z, CalcBuildOr

	dec  c
	dec  c

CalcBuildOr:
	ld   a, (ix + Y)
	inc  a
	ld   h, SrcPa / 800h
	ld   b, 1
	ld   d, BldMap
	call MaskOr

SetBuild:
	ld   (ix + State), Builder
	jp   WriteVal										; It's return will make us exit the proc

NotF5:
	inc  hl
	dec  b
	jr   nz, NotAlpha									; Request to be a basher?

	ld   a, (ix + State)
	and  %00000111
	cp   Basher
	ret  z												; Already one?

	ld   a, (hl)
	dec  a
	ret  m												; Out of ressources?

	ld   (hl), a
	ld   (ix + State), Basher
	jp   WriteVal										; It's return will make us exit the proc

NotAlpha:
	inc  hl
	dec  b
	jr   nz, NotXVar									; Request to be a miner?
														; Ppl usually want to be *majors* no? :]
	ld   a, (ix + State)
	and  %00000111
	cp   Miner
	ret  z												; Already one?

	ld   a, (hl)
	dec  a
	ret  m												; Out of ressources?

	ld   (hl), a
	ld   (ix + State), Miner

	jp   WriteVal										; It's return will make us exit the proc

NotXVar:
	inc  hl
	dec  b
	ret  nz												; Request to be a Digger?

	ld   a, (ix + State)
	and  %00000111
	cp   Digger
	ret  z												; Already one?

	ld   a, (hl)
	dec  a
	ret  m												; Out of ressoures?

	ld   (hl), a
	ld   (ix + State), Digger

	jp   WriteVal										; It's return will make us exit the proc


; Procedure to choose the Lemming at the left
ChooseLeft:
	ld   a, 03Eh
	ld   (CDPatch), a

	ld   hl, (MyLem)
	ld   a, (hl)
	ld   (CDPatch + 1), a

	ld   a, 96h
	ld   (CDPatch + 2), a

	ld   hl, LemPos + X									; hl = Source
	ld   de, LemPos + Action
	ld   a, (LevVar + TotLem)
	call CheckDir
	jp   z, StartDraw

	jr   ChooseDir


; Procedure to choose the Lemming at the right
ChooseRight:
	ld   hl, 0D67Eh
	ld   (CDPatch), hl
	
	ld   hl, (MyLem)
	ld   a, (hl)
	ld   (CDPatch + 2), a

	ld   hl, LemPos + X									; hl = Source
	ld   de, LemPos + Action
	ld   a, (LevVar + TotLem)
	call CheckDir
	jp   z, StartDraw

	jr   ChooseDir


; Procedure to choose the Lemming ontop
ChooseUp:
	ld   a, 03Eh
	ld   (CDPatch), a

	ld   hl, (MyLem)
	inc  hl
	ld   a, (hl)
	ld   (CDPatch + 1), a

	ld   a, 96h
	ld   (CDPatch + 2), a

	ld   hl, LemPos + Y									; hl = Source
	ld   de, LemPos + Action
	ld   a, (LevVar + TotLem)
	call CheckDir
	jp   z, StartDraw

	jr   ChooseHigh


; Procedure to choose the Lemming on the bottom
ChooseDown:
	ld   hl, 0D67Eh
	ld   (CDPatch), hl
	
	ld   hl, (MyLem)
	inc  hl
	ld   a, (hl)
	ld   (CDPatch + 2), a

	ld   hl, LemPos + Y									; hl = Source
	ld   de, LemPos + Action
	ld   a, (LevVar + TotLem)
	call CheckDir
	jp   z, StartDraw

ChooseHigh:
	dec  hl
ChooseDir:
	ld   de, MyLem
	ex   de, hl
	ld   (hl), e
	inc  hl
	ld   (hl), d
	jp   StartDraw


; Procedure to get the lemming which is directly at the right of our current one
; [In]  : hl = Lemming's X/Y position, de = Lemming's action, a = Count, b = CDPatch, c = LD
; [Out] : hl = Lemming's Pointer structure, f = Zero if exists, a = 0FFh
; [Uses] : af, bc, de, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
CheckDir:
	ld   c, 5											; bc = Adder
CDir:
	ld   b, a
	ex   de, hl
	bit  IsDead, (hl)
	ex   de, hl
	jr   nz, IsNeg

CDPatch	 equ $
	ld   a, (hl)										; ""
	sub  0												; Theses 2 lines may be swapped
	jr   c, IsNeg										; He's on the other side!
	jr   z, IsNeg

LowestDelta	equ $ + 1
	cp   0FFh
	jr   nc, IsNeg										; Get the smallest delta!

	ld   (LowestDelta), a
	ld   (NewLemAddr), hl

IsNeg:
	ld   a, b
	ld   b, 0
	add  hl, bc											; Skip to the next lemming!
	ex   de, hl
	add  hl, bc											; Update the action pointer aswell
	ex   de, hl
	dec  a
	jr   nz, CDir


	ld   a, (LowestDelta)
	inc  a
	ld   a, 0FFh
	ld   (LowestDelta), a
	ret  z

NewLemAddr	 equ $ + 1
	ld   hl, 0
	ret


; Procedure to draw one single lemming on the screen
; [In] : ix = lemming structure		
; [Out] : a = 0FFh (IsDead)	
; [Uses] = af, bc, de, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
DrawLem:
	bit  IsDead, (ix + Action)
	ret  nz												; It's dead :~(

	ld   a, (ix + Y)
	cp   2
	jr   nc, NotDead									; What *ARE* you doing so high?

	set  IsDead, (ix + Action)
	ret
	
NotDead:
; Maybe he's the "Chosen one"? -(Matrix)
	ld   hl, (MyLem)
	push ix
	pop  bc
	and  a
	sbc  hl, bc
	ld   a, l
	or   a
	jr   nz, NotHim										; Do we have the right guy?

	ld   a, 3
	ld   (GrayDelta), a									; Patch the routine
	ld   (SpriteLen), a

	ld   b, (ix + X)
	dec  b
	dec  b
	ld   c, (ix + Y)
	ld   a, (ix + Time)
	and  00000011b
	neg
	add  a, c
	sub  8 + 4

	ld   hl, Selected
	push ix
	call DrawSprite										; Now write the Arrow
	pop  ix

	ld   a, 8
	ld   (GrayDelta), a
	ld   (SpriteLen), a

; If he's finishing the level, then we've got to draw him entering the door
NotHim:
	bit  Ezit, (ix + Action)
	jr   z, NoExit

	ld   c, 0
	ld   h, c
	ld   a, Exiter
	jr   NDrawDie

; If he's a walking time bomb, then we've got to write the seconds he has left
NoExit:
	bit  Bomb, (ix + Action)
	jr   z, DrawHim

	ld   a, (ix + Time)
	ld   bc, 0FFh + (Frame * 100h)
DivBy6:
	inc  c
	sub  b
	jp   p, DivBy6										; FIXME

	ld   a, c
	add  a, a
	ld   c, a
	add  a, a
	add  a, a
	add  a, c											; a = a * 16 (16bytes per number)
	ld   c, a
	ld   b, 0
	ld   hl, Number0
	add  hl, bc											; hl = Source Number

	ld   a, 5
	ld   (GrayDelta), a
	ld   (SpriteLen), a

	ld   b, (ix + X)
	dec  b
	ld   a, (ix + Y)
	sub  8 + 6 - 2

	push ix
	call DrawSprite										; Now write the number ontop!
	pop  ix

	ld   c, 0
	ld   a, (ix + Time)
	cp   c
	jp   p, DrawHim										; If his time is up, draw the explosion!
														; FIXME
	ld   h, c
	ld   a, Bomber
	jr   NDrawDie

; Let's draw the sucker now =]
DrawHim:
	ld   a, (ix + State)
	ld   c, 0
	ld   h, c
	and  %00000111										; This filters the basic actions

	cp   Faller
	jr   nz, NDrawFloat
	bit  Float, (ix + Action)							; A floater means > %111 (basic actions)
	jr   z, NDrawDie

	ld   a, Floater										; Set the graphic for the floater

NDrawFloat:
	bit  Die, (ix + Action)
	jr   z, NDrawDie

	ld   a, Dyier										; Set the graphic for the dyier

NDrawDie:
	cp   Climber
	jr   nz, Keep

Keep:
	and  a
	rra
	rr   c												; Same as "SHL a, 6"
	ld   b, a											; bc = Type Offset

	ld   a, (ix + Frames)
	and  %00111000
	add  a, a
	ld   l, a											; hl = Frame Offset
	add  hl, bc

	bit  Dir, (ix + Action)
	jr   z, GoRight

	ld   de, RevData
	ld   a, (ix + X)
	sub  2 + 3
	ld   b, a
	jr   DoDraw

GoRight:
	ld   de, Data										; de = Starting Data Offset
	ld   b, (ix + X)
	dec  b
	dec  b												; Calculate the coordinates

DoDraw:
	add  hl, de											; hl = Final Drawing Offset

	ld   a, 0F8h
	cp   b
	jr   nc, SkipClip

	bit  Dir, (ix + Action)
	jr   z, CheckRVoid
														; If he's off screen and going left
	inc  a
	cp   b
	jr   nz, NotCVoid

	set  IsDead, (ix + Action)							; Mark it as dead :~(

NotCVoid:
	ld   a, (Window)
	or   a
	ret  nz												; He's off screen!

	ld   a, 20h
	ld   (UnderLeftPatch), a

	ld   a, (ix + Y)									; Then draw the lemming!
	sub  7
	push ix

	call DrawSprite

	pop  ix

	ld   a, 18h
	ld   (UnderLeftPatch), a

	ret

CheckRVoid:
	ld   a, 0FFh
	cp   b
	jr   nz, SkipClip

	set  IsDead, (ix + Action)							; Mark it as dead :~(

SkipClip:
	ld   a, (ix + Y)									; Then draw the lemming!
	sub  7
	push ix

	call DrawSprite

	pop  ix
	ret


; Procedure to copy over the viewable screen window
; [In] = NULL						
; [Uses] : af, bc, de, hl			
; [Out] : a = 0, bc = 16
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
ShowWin:
	ld   de, Page2a
	ld   a, (Window)
	ld   b, 0
	ld   c, a
#ifdef Und
	ld   hl, Under
#else
	ld   hl, SrcPa
#endif
	add  hl, bc											; hl = Source Graphx + Window Disp
	push bc
	ld   c, 16											; bc = 16
	ld   a, 52											; a = Vertical loop

WinPa:
	ldir

	ld   c, 16
	add  hl, bc

	dec  a
	jr   nz, WinPa

#ifdef Und
	ld   hl, Under
#else
	ld   hl, SrcPb
#endif
	pop  de
	add  hl, de
	ld   de, Page2b
	ld   a, 52

WinPb:
	ldir

	ld   c, 16
	add  hl, bc

	dec  a
	jr   nz, WinPb
	ret


; Procedure to draw a 8x8x4 Sprite (AND/OR)
; [In] : hl = Src, b = X, a = Y, [SpriteLen]
; [Out] : c = 0, ab = BitMask
; [Uses] : af, bc, de, hl, ix
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
DrawSprite:
	ld   c, a
	ld   a, (SpriteLen)
	ld   e, a
	add  a, c
	dec  a
	jp   m, Return
	jr   nc, IsLow

	inc  a
	ld   d, 0
	ld   (SpriteLen), a
	sub  e
	neg
	ld   e, a
	add  hl, de
	ld   c, d											; He's being clipped from the top!

IsLow:
	push hl
	pop  ix												; Load ix with hl
	ld   a, c
	add  a, a
	add  a, a

DrawPage:												; May tell to draw the sprite reversed
	ld   h, Page2a / 400h								; (Code patch)
	ld   l, a

	ld   a, b
	rra
	add  hl, hl
	rra
	add  hl, hl
	rra													; a = X / 8

Window	 equ $ + 1									; Code patching, it's actually the window
	sub  5 												; variable put up as a immediate subst.
	inc  a
	jp   m, Return			; FIXME
	jr   nz, NotBorder									; We're getting clipped from the left?

	dec  hl
	ld   a, FirstPixel - DoFirstPixel
	ld   (DoFirstPixel), a
	jr   AdjustH

NotBorder:
	cp   20h
UnderLeftPatch:
	jr   NotMaxLeft

	dec  hl
	ld   a, FirstPixel - DoFirstPixel
	ld   (DoFirstPixel), a
	jr   AdjustH

NotMaxLeft:
	dec  a
	cp   16
	jp   p, Return										; Too much to the right

	cp   15
	jp   m, NoClip

	add  a, l
	ld   l, a											; Get rid of a
	ld   a, SecondPixel - FirstPixel - 2
	ld   (FirstPixel), a
	ld   a, 16
	ld   (SecondPixel), a
	jr   AdjustH

NoClip:
	add  a, l
	ld   l, a

AdjustH:
	ld   a, b
	and  %00000111
	ld   b, a
	add  a, a
	add  a, b											; a = X * 3

	sub  3 * 7											; Skip the Left portion of it
	neg
SpriteLen	equ $ + 1
	ld   e, 8											; e = Length loop
	ld   (MDrawY1), a
	ld   (MDrawY2), a
	xor  a												; Clear the carry flag
	ld   b, a

StartMDrawLoop:											; Here b will always be 0 :)
	ld   c, b
	ld   d, b											; hl = Source
GrayDelta equ $ + 2
	ld   a, (ix + 8)									; cd = 2st Gray Layer

MDrawY1	 equ $ + 1										; Heavy code patching occrurs here! :o)
	jr   $ + 2

	rra
	rr   d
	rra
	rr   d
	rra
	rr   d
	rra
	rr   d
	rra
	rr   d
	rra
	rr   d
	rra
	rr   d												; Shift a & accordingly
	ld   c, a
	ld   a, (ix)										; ab = 1st Gray Layer

MDrawY2	 equ $ + 1										; Heavy code patching occrurs here! :o)
	jr   $ + 2

	rra
	rr   b
	rra
	rr   b
	rra
	rr   b
	rra
	rr   b
	rra
	rr   b
	rra
	rr   b
	rra
	rr   b												; Shift a & accordingly

DoFirstPixel equ $ + 1
	jr   $ + 2

	ld   (OldA), a										; Preserve the "a" value
	or   c
	cpl
	and  (hl)
OldA	 equ $ + 1
	or   0
	ld   (hl), a										; Write the first pixel

	ld   a, h
Del1	 equ $ + 1
	add  a, Delta
	ld   h, a

	ld   a, (OldA)
	or   c
	cpl
	and  (hl)
	or   c
	ld   (hl), a										; Write the second layers' last pix

	ld   a, h
Del2	 equ $ + 1
	sub  Delta
	ld   h, a

FirstPixel equ $ + 1
	jr   $ + 2

	inc  hl
	ld   a, b
	or   d
	cpl
	ld   c, a											; Preserve the mask
	and  (hl)
	or   b
	ld   (hl), a										; Write the next pixel

	ld   a, h
Del3	 equ $ + 1
	add  a, Delta
	ld   h, a

	ld   a, c											; Restore the mask
	and  (hl)
	or   d
	ld   (hl), a										; Write the second layers' first pix

	ld   a, h
Del4	 equ $ + 1
	sub  Delta
	ld   h, a

SecondPixel	 equ $ + 1
	ld   bc, 16 - 1
	add  hl, bc
	inc  ix

	dec  e
	jr   nz, StartMDrawLoop

Return:
	ld   a, 8
	ld   (SpriteLen), a
	ld   (GrayDelta), a

	xor  a												; Internal patches...
	ld   (FirstPixel), a
	ld   (DoFirstPixel), a
	ld   a, 15
	ld   (SecondPixel), a

	ret


; Procedure to or a line to the screen
; [In]   : hl = Source, de = Destination
; [Out]  : b = 16, c = 0
; [Uses] : af, bc, de, hl
DrawOrLine:
	ld   bc, 01008h

WaveYLoop:
	push bc
	ld   c, (hl)
	inc  hl

WaveXLoop:
	ld   a, (de)
	or   c
	ld   (de), a
	inc  de
	djnz WaveXLoop

	pop  bc
	dec  c
	jr   nz, WaveYLoop
	ret


; Procedure to patch a 8bit Sprite with a single map (1byte)
; [In] : a = Y, c = X, h = Dest/400h, d = Mask, b = Y Length
; [Out] : c = 0, ab = BitMask
; [Uses] : af, bc, de, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
MaskOr:
	cp   0
	jr   NoORClip

	add  a, b
	ld   b, a
	xor  a												; Adjust the length accordingly
	
	cp   b
	ret  p												; We ran out of things to draw!

NoORClip:
	call CalcAddr

	add  a, a
	add  a, a

	sub  4 * 7											; Skip the Left portion of it
	neg
	ld   c, b
	ld   (MORY), a
	
StartMOrLoop:
	ld   b, 0h
	ld   a, d

MORY	 equ $ + 1										; Heavy code patching occrurs here! :o)
	jr   $ + 2

	and  a												; Clear the carry flag
	rra
	rr   b
	and  a
	rra
	rr   b
	and  a
	rra
	rr   b
	and  a
	rra
	rr   b
	and  a
	rra
	rr   b
	and  a
	rra
	rr   b
	and  a
	rra
	rr   b												; Shift a & accordingly

	ld   d, a

Mask4Or:
	or   (hl)
	ld   (hl), a
	inc  hl
	ld   a, b
	or   (hl)
	ld   (hl), a										; Patch SrcPa

	ld   a, h
OR2nd	 equ $ + 1
	add  a, (SrcPb - SrcPa) / 100h
	ld   h, a

	ld   a, b
	or   (hl)
	ld   (hl), a
	dec  hl
	ld   a, d
	or   (hl)
	ld   (hl), a										; Patch SrcPb

	ld   a, d
ORAddr	 equ $ + 2
	ld   de, (SrcPa - SrcPb) + 32
	add  hl, de											; Get back to SrcPa

	ld   d, a

	dec  c
	jr   nz, Mask4Or

	ret


; Procedure to mask a 8bit Sprite (AND)
; [In] : a = Y, c = X, h = Dest/400h, de = Src, b = Y Length
; [Out] : c = 0, ab = BitMask			
; [Uses] : af, bc, de, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
MaskAnd:
	cp   0
	jp   p, NoANDClip						; FIXME

	push hl
	ex   de, hl
	ld   hl, 32

ReduceANDa:
	dec  b
	add  hl, de											; Start lower!

	inc  a
	jr   nz, ReduceANDa									; Keep clipping it!
	ex   de, hl
	pop  hl
	cp   b
	ret  p												; We ran out of things to draw!

NoANDClip:
	call CalcAddr

	add  a, a
	add  a, a

	sub  4 * 7											; Skip the Left portion of it
	neg
	ld   c, b
	ld   (MANDY), a
	
StartMAndLoop:
	ld   a, (de)
;	or   (hl)											; Preserve the hard's poportion

	ld   b, 0FFh
	inc  de

MANDY	 equ $ + 1										; Heavy code patching occrurs here! :o)
	jr   $ + 2

	scf
	rra
	rr   b
	scf
	rra
	rr   b
	scf
	rra
	rr   b
	scf
	rra
	rr   b
	scf
	rra
	rr   b
	scf
	rra
	rr   b
	scf
	rra
	rr   b												; Shift a & accordingly

AndPat1:
	or   (hl)											; Let the hard metal stay hard!
	inc  hl
	ld   (AVal), a										; Preserve the a's value!
	ld   a, b
AndPat2:
	or   (hl)
	ld   b, a

	ld   a, (SrcPa - Under) / 100h
	add  a, h
	ld   h, a	

	push de
AVal	 equ $ + 1
	ld   d, 0

	ld   a, b
	and  (hl)
	ld   (hl), a
	dec  hl
	ld   a, d
	and  (hl)
	ld   (hl), a										; Mask SrcPa

AndAddr  equ $ + 1
	jr   SkipUnd

	ld   a, h
	add  a, (Under - SrcPa) / 100h
	ld   h, a

	ld   a, d
	and  (hl)
	ld   (hl), a
	inc  hl
	ld   a, b
	and  (hl)
	ld   (hl), a										; Mask SrcPb
	dec  hl

	ld   a, h
	add  a, (SrcPa - Under) / 100h
	ld   h, a

SkipUnd:
	ld   a, h
	add  a, (SrcPb - SrcPa) / 100h
	ld   h, a

	ld   a, d
	and  (hl)
	ld   (hl), a
	inc  hl
	ld   a, b
	and  (hl)
	ld   (hl), a										; Mask SrcPb

	ld   de, 10000h - (SrcPb + (43 * 2 * 128 / 8) + 1)
	add  hl, de
	xor  a

	cp   h
	jp   p, NoMAndoClip			; FIXME
	pop  de
	ret													; Lower bound clipping

NoMAndoClip:
	ld   de, Under + 32 + (43 * 2 * 128 / 8)
	add  hl, de											; Get back to SrcPa

	pop  de
	dec  c
	jp   nz, StartMAndLoop

	ret

; Procedure to calculate the address of a given (X, Y) coordinate
; [In] : a = Y, c = X, h = Src/4
; [Out] : hl = MapOfs, a = PixelDepth
; [Uses] : af, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
CalcAddr:
	add  a, a
	add  a, a											; a = Y * 4

	ld   l, a

	ld   a, c
	add  hl, hl
	rra
	add  hl, hl											; Reset Carry
	rra
	add  hl, hl											; hl = Y * 32
	rra

	or   l
	ld   l, a

	ld   a, 7
	and  c

	ret


; Procedure to check if a location has hard metal
; [In] : a = Y, e = X, 	
; [Out] : af = Bool, hl = MapOfs, de = SrcOfs, c = PixelDepth, b = 0
; [Uses] : af, bc, de, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
IsHard:
	cp   52
	jr   nc, IsOn

	add  a, a
	add  a, a											; a = Y * 4

	ld   h, Under / 800h
	ld   l, a											; Carry is 0

	ld   a, e
	add  hl, hl
	rra
	add  hl, hl											; Reset Carry
	rra
	add  hl, hl											; hl = Y * 32
	rra

	or   l
	ld   l, a											; hl = Source offset

	ld   a, 7
	and  e
	ld   c, a
	ld   b, 0

	ex   de, hl											; de = Source offset
	ld   a, (de)										; Get the pixel
	ld   hl, BitMap
	add  hl, bc
	and  (hl)											; Hand out the result

	ret

IsOn:
	xor  a												; Clear the carry flag!
	ret


; Procedure to check if a location has dirt or not
; [In] : a = Y, e = X, 	
; [Out] : af = Bool, hl = MapOfs, de = SrcOfs, c = PixelDepth, b = 0
; [Uses] : af, bc, de, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
IsDirt:
	cp   52
	jr   nc, IsOn

	ld   (LastY), a

	add  a, a
	add  a, a											; a = Y * 4

	ld   h, SrcPa / 800h
	ld   l, a											; Carry is 0

	ld   a, e
	add  hl, hl
	rra
	add  hl, hl											; Reset Carry
	rra
	add  hl, hl											; hl = Y * 32
	rra

	or   l
	ld   l, a											; hl = Source offset

	ld   a, 7
	and  e
	ld   c, a
	ld   b, 0

	ex   de, hl											; de = Source offset
	ld   a, (de)										; Get the pixel
	ld   hl, SrcPb - SrcPa
	add  hl, de
	or   (hl)
	ld   hl, BitMap
	add  hl, bc
	and  (hl)											; Hand out the result

	ret


; Procedure to check if there's dirt at (X, Y + 1)
; [In] : hl = MapOfs, de = SrcOfs
; [Out] : af = Bool, hl = MapOfs, de = SrcOfs + XLength
; [Uses] : af, bc, de, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
CheckNextDirt:
LastY	 equ $ + 1
	ld   a, 0
	inc  a
	ld   (LastY), a
	cp   52
	jr   nc, IsOn

	ld   bc, 32
	ex   de, hl
	add  hl, bc
	ld   a, (hl)

	ld   bc, SrcPb - SrcPa
	add  hl, bc

	or   (hl)											; Get SrcPa | ScrPb
	ex   de, hl
	and  (hl)											; Carry is off

	ret													; Wanna check another one?  Do :
														; "d = d - (SrcPa - SrcPb) / 100h"

; Procedure to replace the screen with a background
; [In]   : hl = Source, de = Destination
Kill6:
	ld   bc, 15
	exx
	ld   b, 6

KillLoop:
	exx
	ld   a, (hl)
	ld   (de), a

	inc  hl
	inc  de
	ld   a, (hl)
	ld   (de), a

	add  hl, bc
	ex   de, hl
	add  hl, bc
	ex   de, hl

	exx
	djnz KillLoop	
	ret


; Procedure to write to number of lemmings In/Out/His
; [In] = NULL
; [Out] : 
; [Uses] : all
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
WriteIO:
	ld   de, Page1a + 14 + (52 * 16)
	ld   hl, BottomPa + 14
	call Kill6
	exx
	call Kill6											; Erase the previous values

	ld   de, Page1b + 14 + (52 * 16)
	ld   hl, BottomPb + 14
	call Kill6
	exx
	call Kill6
	
	ld   hl, LevVar + LemNeed

	ld   a, (Players)
	or   a												; cp   P1
	jr   z, DoWrite

	ld   hl, HisLemIn

DoWrite:
	ld   de, 03B01h
	ld   b, 77h
	call WriteNumber

	ld   hl, MyLemIn
	ld   de, 03501h
	ld   b, 077h
	call WriteNumber
	ret


; Procedure to write the new Lemmings values on the screen
; [In] = NULL
; [Out] : e = 0
; [Uses] : af, bc, hl, de
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
WriteVal:
; First step is to rewrite the background
	ld   a, 5
	ld   (GrayDelta), a
	ld   (SpriteLen), a

	ld   hl, BottomPa + 16
	ld   de, Page1a + (53 * 128 / 8)
	ld   bc, 5 * 128 / 8
	ldir

	ld   hl, BottomPb + 16
	ld   de, Page1b + (53 * 128 / 8)
	ld   bc, 5 * 128 / 8
	ldir

	ld   hl, LevVar										; hl = Number of workers left
	ld   de, 03508h										; e = # of repeats
	ld   bc, 00308h

	call WriteNumber									; Write the number and then the time!

	call WriteIO

WriteTime:
	ld   hl, MinLeft
	ld   de, 03802h
	ld   bc, 05906h										; Write the time


; Procedure to write the new Lemmings values on the screen
; [In] : b = XStart, c = Delta, d = YStart, e = Loops, hl = number array
; [Out] : e = 0
; [Uses] : af, bc, hl
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
WriteNumber:
; Hack the DrawSprite procedure so that it can draw our numbers directly on the screen!
	ld   a, d
	ld   (Height1), a
	ld   (Height2), a
	ld   a, c
	ld   (IncrNum), a
	ld   a, Delta2										; Our new delta
	ld   (Del1), a
	ld   (Del2), a
	ld   (Del3), a
	ld   (Del4), a
	ld   a, Page1a / 400h
	ld   (DrawPage + 1), a

	ld   a, (Window)
	add  a, a
	add  a, a
	add  a, a											; a = Window * 8
	add  a, b											; Starts at the 4th pixel
	ld   (XValue), a

	push ix

; Next step is to write all the values on the screen
WriteNums:
	ld   a, 5
	ld   (GrayDelta), a
	ld   (SpriteLen), a

	ld   a, (hl)										; a = the number itself
	ld   bc, 00AFFh
	push hl												; Preserve the incrementative addr.
	push de												; Repeats

DivLoop:
	inc  c
	sub  b
	jr   nc, DivLoop
	add  a, b											; c = a / 10 ; a = a % 10

	add  a, a
	ld   b, a
	add  a, a
	add  a, a
	add  a, b											; a = a * 10

	push af												; Preserve the second digit

	ld   a, c
	add  a, a
	ld   c, a
	jr   z, SkipVal0									; If a = 0, then skip it!
	add  a, a
	add  a, a
	add  a, c

	ld   hl, Number0
	ld   b, 0
	ld   c, a
	add  hl, bc											; hl = Number source

XValue	equ $ + 1
	ld   b, 0
Height1	 equ $ + 1
	ld   a, NumberH

	call DrawSprite

	ld   a, 5
	ld   (GrayDelta), a
	ld   (SpriteLen), a

SkipVal0:
	pop  af												; Restore the last digit

	ld   hl, Number0
	ld   b, 0
	ld   c, a
	add  hl, bc

	ld   a, (XValue)
	add  a, 3
	ld   b, a
IncrNum	 equ $ + 1
	add  a, 11 - 3
	ld   (XValue), a									; Increment to the next phase
Height2	 equ $ + 1
	ld   a, NumberH
	call DrawSprite										; Do the second digit

	pop  de
	pop  hl

	inc  hl												; Skip to the next on-screen digit
	dec  e
	jr   nz, WriteNums									; Do all the pair

	ld   a, Delta
	ld   (Del1), a
	ld   (Del2), a
	ld   (Del3), a
	ld   (Del4), a
	ld   a, Page2a / 400h
	ld   (DrawPage + 1), a

	ld   a, 8
	ld   (GrayDelta), a
	ld   (SpriteLen), a

	pop  ix
	ret

; Procedure to clear the first Page
; [In] : bc = Length
FlipPages:
	ld   hl, Page2a
	ld   de, Page1a
	push bc
	ldir

	ld   hl, Page2b
	ld   de, Page1b
	pop  bc
	ldir												; Flip the pages
	ret


; Procedure to clear a 1K buffer
; [In] : hl = Destination
ClearPage:
	ld   bc, 1023
	ld   d, h
	ld   e, l
	inc  de
	ld   (hl), 0
	ldir
	ret


; Procedure to wait until the "Second" or "Exit" key has been pressed
; [In] = NULL				
; [Out] : z = Exit, nz = 2nd
; [USES] = a
;<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>---<[]>
GetEnter:	
	ld   a, %00111111
	out  (1), a

LoopEnt1:
	in   a, (1)
	or   %10011111
	inc  a
	jr   z, LoopEnt1									; Wait for keypress
	bit  5, a											
	push af

LoopEnt2:
	in   a, (1)
	or   %10011111
	inc  a
	jr   nz, LoopEnt2									; Wait for release
	pop  af
	ret


IntDest	equ 09E9Eh
IntTab	equ 08E00h

#include "Grey.asm"
#include "Decomp.asm"

; Timer related equates
Frame	equ 7											; Frames per second
IntSpd	equ 170
GameSpd	equ 170 / Frame

;#include "SendStr.asm"
#include "SendTest.asm"

Var:	.db VProgram, 8
Title:	.db "Lemmingz"
OutS:	.db "Out:", 0
InS:	.db "In:", 0
TimeS:	.db "Time:", 0
HisS:	.db "His:", 0
TieS:	.db "It's a tie", 0
WonS:	.db "You won", 0
LostS:	.db "You lost", 0

; Here are the graphics used in the game
Drawing:
#include "Title.inc"									; Compressed
BottomPa:
#include "LowBar.inc"									; Not Compressed
MEntry:
#include "Entry.inc"									; Not compressed (2 small)
MExit:
#include "Exit.inc"										; ""

BottomPb equ BottomPa + (12 * 128 / 8)

Data:
#include "Movement.inc"

; Now for the 2 sided masks
BombMp:	.db %11111000
		.db %11100000
		.db %11000000
		.db %11000000
		.db %10000000
		.db %10000000
		.db %10000000
		.db %10000000
		.db %10000000
		.db %10000000
		.db %11000000
		.db %11000000
		.db %11100000
		.db %11111000

MineMp:	.db %11100011
		.db %11000001
		.db %10000000
		.db %00000000
		.db %00000000
		.db %00000001
		.db %10000011
		.db %11000111

BashMp:	.db %00011111
		.db %00001111
		.db %00001111
		.db %00001111
		.db %00001111
		.db %00001111
		.db %00001111
		.db %00011111

RevLen	equ $ - Data + 1
RevData	equ 0AE80h										; Reversed data stored location

; Bitmap tables (Using the real definition of it : Not MS's defition ie : image)
BitMap:	.db	80h, 40h, 20h, 10h, 8, 4, 2, 1				; Position related bit-map
DigMap:	.db %00000011
BldMap	equ %11100000
BlkTMap	equ %10110100
BlkMap	equ %11000000

BlokMp:	.db %11001111
		.db %11001111
		.db %11001111
		.db %01001011
		.db %11001111
		.db %11001111
		.db %11001111

TileBckgnd1:
		.db %00001100
		.db %00111110
		.db %01111111
		.db %01111111
		.db %11111110
		.db %11111110
		.db %01111100
		.db %00110000

Number0	equ 09F9Ch

; Selector 
Selected:
	.db %11111000
	.db %01110000
	.db %00100000
	.db %01110000
	.db %00100000
	.db %00000000

; Key definitions
	; Row 0
Down	equ 0
Left	equ 1
Right	equ 2
Up		equ 3
	; Row 6
More	equ 7
Exit	equ 6
Second	equ 5
F1		equ 4
F2		equ 3
F3		equ 2
F4		equ 1
F5		equ 0
	; Column 2
Alpha	equ 7
XVar	equ 7
Del		equ 7
    ; Last column
Enter	equ 0


; High byte DWORD alligned for speed opt. in the single pixel routines
; They must all be divisible by 800h
; The Page which we use to flip to make the greyscale effect
Page1a	equ 0FC00h										; Screen related addresses (1K)
Page1b	equ 0CA00h										; All rounds of 256d 100h
Page2a	equ 0A000h
Page2b  equ 0A400h

; The Flames related variables
Flame1C	equ 09E88h
Flame2C	equ 09E89h
Flame3C	equ 09E8Ah

Waves	equ 08F01h

; The on-screen level background/foreground (Look/underground)
SrcPa	equ 09000h										; Level related addresses (1664Bytes)
SrcPb	equ 09800h										; Each 2K alligned
Under	equ 0A800h										; Delta Src must equal Delta Und

; Lemming related variable
LevVar	equ _textShadow
HisVar	equ _textShadow + 48
Preset	equ _textShadow + 48 + 32						; Can't go over 256 bytes (combined)
LemPos	equ 09680h										; Lemming's structure
HisPos	equ 09720h
MyLem	equ 09E80h										; Current active lemmings
HisLem	equ 09E82h
OutLem	equ 09E84h										; Next lemming out of the main
LemAdd	equ 09E85h										; Next lemming counter pointer (*5)
TotOLem	equ 09E86h										; Next lemming counter (*1)

MyLemIn equ 09E8Bh										; My number of lemmings in
HisLemIn equ 09E8Ch

Delta	equ (Page2b - Page2a) / 100h
DeltaR	equ (Page2a - Page2b) / 100h
Delta2	equ (Page1b - Page1a) / 100h

TopFlame1	equ 08A00h
RevTopFlame	equ 08B00h

; Variables for the external level loaders
LESeek	equ VString										; What type we're looking for
IDWord	equ 04D4Ch										; Loader Level plugin ID "LM"
LevName	equ _textShadow
BootTmp equ 0FB00h										; Init.  mem which won't be killed!


; Player variables
Players	equ 9E87h
P1		equ 0
P2M		equ 1
P2S		equ 2

; On screen "number of worker left" defines
NumberH	equ 53
ClimbNo	equ 2
FloatNo	equ ClimbNo + 12
BombNo	equ FloatNo + 12
BlockNo	equ BombNo  + 12
BuildNo equ BlockNo + 12
BashNo	equ BuildNo + 12
MineNo	equ BashNo  + 12
DigNo	equ MineNo  + 12

; Relative level data Starting at LevelData
NoClimb	equ 0
NoFloat equ 1
NoBomb	equ 2
NoBlock	equ 3
NoBuild	equ 4
NoBash	equ 5
NoMine	equ 6
NoDig	equ 7

StartX	equ 8
StartY	equ 9
EndX	equ 10
EndY	equ 11
StartX2	equ 12
StartY2	equ 13
EndX2	equ 14
EndY2	equ 15
Trap1X	equ 16
Trap1Y	equ 17
Trap1A	equ 18
Trap1C	equ 19
Trap2X	equ 20
Trap2Y	equ 21
Trap2A	equ 22
Trap2C	equ 23
Trap3X	equ 24
Trap3Y	equ 25
Trap3A	equ 26
Trap3C	equ 27
Min		equ 28
Sec		equ 29
TotLem	equ 30
LemNeed	equ 31
SpdLem	equ 32
LemIn1	equ 33
LemIn2	equ 34
LemIn3	equ 35

Desc	equ 097C0h
LemInS1	equ 09F06h
LemInS2	equ 09F38h
LemInS3	equ 09F6Ah

; The Lemming's structure :
X		equ 0	; X coordinate	: BYTE
Y		equ 1	; Y coordinate	: BYTE
Action	equ 2	; Action Flags	: BYTE
State	equ 3	; State/Frames	: BYTE
Frames	equ 3	; " 				 "
Time	equ 4	; Time at which the bomber started
; At his legs, (X = X + 2, Y = Y + 8)

; Lemmings' Flags			[Required State]
Climb	equ 0			;*	0 : Walker
Float	equ 1			;*	6 : Faller
Bomb	equ 2			;*	none
Die		equ 3			;*	6 : Faller, Not Flag 4 : Float
Ezit	equ 4			;*
First	equ 5			;*  First time entering the board
Dir		equ 6			;*  none (Cleared = Right)
IsDead	equ 7			;*  Lemming's dead

; Lemmings' States			[Hor. Direction]	[Main Action]		[Exception]				[Fr]
Walker	equ	0			;*	Right/Left			Walk				No ground/wall			1/I
Blocker equ 1			;*	None				Stay still			No ground				1/I
Builder	equ 2			;*	Right/Left			Add block and climb	Out of blocks			4/32
Basher	equ 3			;*	Right/Left			Dig straight		No wall					2/I
Miner	equ 4			;*	Right/Left			Dig straight & down	No ground				8/I
Digger	equ 5			;*	None				Dig down			No ground/wall			4/I
Faller	equ 6			;*	None				Plunging down		Is ground/off screen	1/I
Climber	equ 7			;*	None				Climb				No wall					2/I
; [11111|111] <-- Curren State   : (Frame) & %11111000 : Already multiplied by 8!
;  ^^The lemming's current Frame : (Frame) & %00000111
Floater equ 8
Bomber  equ 9
Dyier   equ 10
Exiter	equ 11

; Lemmings' direction is either (0 : Right) or (Delta : Left)
;   : Not started yet
; - : Partially completed
; / : Half done
; * : Fully completed
; ~ : Buggy

.end

; 86 Game memory mapping :
; Memory span	Buffer Length		Expected data

; 8A00			 256b				Flame1Top
; 8B00			 256b				Flame1SideRev
; 8E00-8F00		 257b				IntTable
; 8F01-8F81		 128b				Waves
	;127b free
; 9000-967F 	1664b				SrcPa*
; 9680-97AF		 320b				LemPos (Max of 64 lemmingz)
; 97C0-97F2		  50b				Level Description
; 97F3			   1b				Contrast level
    ; 15b free
; 9800-9E7F 	1664b				SrcPb*
; 9E80-9E81		   2b				MyLem
; 9E82-9E83		   2b				HisLem
; 9E84			   1b				OutLem
; 9E85			   1b				LemAdd
; 9E86			   1b				TotOLem
; 9E87			   1b				Players
; 9E88			   1b				Flame1C
; 9E89			   1b				Flame2C
; 9E8A			   1b				Flame3C
; 9E8B			   1b				MyLemIn
; 9E8C			   1b				HisLemIn
	; 20b free
; 9E9E-9F05		 104b				IntDest
; 9F06-9F37		  50b				Lemming [In] comment 1
; 9F38-9F69		  50b				Lemming [In] comment 2
; 9F6A-9F9B		  50b				Lemming [In] comment 3
; 9F9C-9FFF		 100b				Numbers
; A000-A3FF		1024b				Page2a*
; A400-A7FF		1024b				Page2b*
; A800-AE7F 	1664b				Under*
; AE80-B47F		1536b				Reversed lemming's animation
; B480-B57F		 256b				Reversed flames animation
; B580-B58E		  14b				Reversed Bomb mask
; B58F-B597		   8b				Reversed Miner mask
; B598-B5A5		   8b				Reversed Basher mask

; C000-C9FF 	2560b				RAM
	; C0F9
; CA00-CDFF 	1024b				Page1b
; CE00-D747 	2476b				RAM
; D748-Drawing	[Variable]			Code space
; Drawing		 728b				Introduction title "Lemmingz" drawing	(64.5% Compressed)
; Background	   8b				Level introduction background
; Bottom		 384b				Low menu bar drawing
; Entry			  32b				Entry door drawing
; Exit			  16b				Exit door drawing
; Data			1536b				Lemming's animation
; Flames		 256b				Right side flame animation
; Mask			  54b				Mask Tables
; Selectr		   6b				Selector drawing
; Background	   8b				Init/Closing background tile

; FB00-FBFF		 256b				Stack RAM
; FC00-FFFF		1024b				Page 1a